import * as React from "react";
interface IProps {
    size?: number;
    circleWidth?: number;
    progressWidth?: number;
    knobRadius?: number;
    value?: number;
    stepSize?: number;
    min?: number;
    max?: number;
    circleColor?: string;
    progressColor?: string;
    gradientColorFrom?: string;
    gradientColorTo?: string;
    knobColor?: string;
    onChange: ((value?: number) => void);
    disabled?: boolean;
    shadow?: boolean;
    showTooltip?: boolean;
    showPercentage?: boolean;
    tooltipSize?: number;
    tooltipColor?: string;
}
interface IPoint {
    x: number;
    y: number;
}
interface IState {
    angle: number;
    currentStepValue: number;
    isMouseMove: boolean;
}
export declare class CircleSlider extends React.Component<IProps, IState> {
    static defaultProps: Partial<IProps>;
    private maxLineWidth;
    private radius;
    private countSteps;
    private stepsArray;
    private circleSliderHelper;
    private mouseHelper;
    private svg;
    constructor(props: IProps);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    updateAngle: (angle: number) => void;
    updateSlider: () => void;
    updateSliderFromProps: (valueFromProps: number) => void;
    getCenter: () => number;
    getAngle: () => number;
    getPointPosition: () => IPoint;
    getStepsArray: (min: number, stepSize: number) => number[];
    getPath: () => string;
    handleMouseMove: (event: Event) => void;
    handleMouseUp: (event: Event) => void;
    handleMouseDown: (event: React.MouseEvent<SVGSVGElement>) => void;
    handleTouchMove: any;
    handleTouchUp: () => void;
    handleTouchStart: () => void;
    render(): JSX.Element;
}
export {};
